#!/usr/bin/env python3

import time
import base64
import http.client
import urllib.parse
import subprocess as sp
from datetime import datetime


HOST = 'yourserver.int'
PORT = 8000
AUTH = 'source:hackme'
MOUNT = 'main.mp3'


def log(msg):
	ts = datetime.utcnow().strftime('%H:%M:%S')
	print('\033[0;36m{}\033[0m {}'.format(ts, msg))


def gettags():
	try:
		return sp.check_output([
			'xdotool', 'search', '-name',
			r' \| Mixxx [0-9][0-9\.]+[0-9] x64$',
			'getwindowname']).decode('utf-8', 'replace')
	except:
		return None


def main():
	log('hhh')
	last_tag = None
	auth = "Basic " + base64.b64encode(AUTH.encode('utf-8')).decode('utf-8')
	while True:
		time.sleep(0.5)
		tag = gettags()
		if tag is None:
			log('nulltag')
			continue
		
		if last_tag == tag:
			continue
		
		log('new tag: {}'.format(tag))
		last_tag = tag
		
		tag = tag.replace(' `` ', ' - ')
		tag, _ = tag.split(' | Mixxx ', 1)
		url = "https://{host}{port}/admin/metadata?mode=updinfo&mount=/{mount}&charset=UTF-8&song={tag}".format(
			host = HOST,
			port = PORT,
			mount = MOUNT,
			tag = urllib.parse.quote_plus(tag))

		conn = http.client.HTTPConnection(HOST, PORT, timeout=3)
		conn.request('GET', url, headers={
			"Authorization": auth
		})
		r = conn.getresponse()
		log('server response = {}'.format(r.status))
		
		rt = r.read().decode('utf-8')
		rt = rt.replace('<?xml version="1.0"?>', '')
		rt = rt.replace('\r', '').replace('\n', '')
		log(rt)


if __name__ == '__main__':
	main()
